<?php
require_once '/var/packages/Spreadsheet/target/phpoffice/common/Autoloader.php';
require_once '/var/packages/Spreadsheet/target/phpoffice/presentation/Autoloader.php';

\PhpOffice\Common\Autoloader::register();
\PhpOffice\PhpPresentation\Autoloader::register();

$ob_file = fopen('/var/log/synoffice.log','a');

function ob_file_callback($buffer)
{
	if ($buffer !== '') {
		global $ob_file;
		fwrite($ob_file,"slides export: " . $buffer);
	}
}

ob_start('ob_file_callback');

function genSlideTestcase($src, $dst) {
	if (!file_exists($src) || !file_exists($dst)) {
		return;
	}
	$handle = fopen($src, 'r');
	$jsonString = fread($handle, filesize($src));
	fclose($handle);
	$json = json_decode($jsonString);
	$attachment = $json->attachment;

	$i = 1;
	do {
		if (file_exists("/tmp/slide_testcase/export/case$i")) {
			$i++;
			continue;
		}
		break;
	} while (true);

	$targetDir = "/tmp/slide_testcase/export/case$i";
	mkdir($targetDir, 0700, true);
	mkdir("$targetDir/media", 0700);
	foreach ($attachment as $id => $object) {
		copy($object->path, "$targetDir/media/" . $id);
	}
	copy($src, "$targetDir/test.json");
	copy($dst, "$targetDir/test.pptx");
}

function main($argv) {
	global $i18n;
	global $comment;

	$src = $argv[1];
	$dst = $argv[2];
	$lang = $argv[3];
	$lang = str_replace(array('.', '/'), '', $lang);
	$strings = file_get_contents("/var/packages/Spreadsheet/target/ui/texts/$lang/strings");
	$i18n = array();
	foreach (array(
		'edit_text_style_title' => 'title',
		'edit_text_style_subtitle' => 'sub_title',
		'edit_text_style_first_level' => 'level_1',
		'edit_text_style_second_level' => 'level_2',
		'edit_text_style_third_level' => 'level_3',
		'edit_text_style_fourth_level' => 'level_4',
		'edit_text_style_fifth_level' => 'level_5',
		'edit_text_style_sixth_level' => 'level_6',
		'edit_text_style_seventh_level' => 'level_7',
		'edit_text_style_eighth_level' => 'level_8',
		'edit_text_style_ninth_level' => 'level_9'
	) as $key => $value) {
		if (false === ($pos = strpos($strings, $key))) {
			continue;
		}
		if (false === ($pos = strpos($strings, '"', $pos))) {
			continue;
		}
		if (false === ($pos2 = strpos($strings, '"', $pos + 1))) {
			continue;
		}
		if ($pos2 <= $pos) {
			continue;
		}
		$i18n[$value] = substr($strings, $pos + 1, $pos2 - $pos - 1);
	}

	$reader = new \PhpOffice\PhpPresentation\Reader\ProseMirror();
	$phpPresentation = $reader->load($src);
	$phpPresentation->setLanguage($lang);

	$writer = new \PhpOffice\PhpPresentation\Writer\PowerPoint2007($phpPresentation);
	$writer->save($dst);

	$zip = new ZipArchive();
	$zip->open($dst);
	$zip->addFile($src, 'synoPresentation.json');
	$zip->close();

	if (file_exists('/tmp/gen_slide_testcase')) {
		genSlideTestcase($src, $dst);
	}

	chown($dst, 'office');
	chgrp($dst, 'office');
}

main($argv);
?>
