from .read_only_worksheet import SynoReadOnlyWorksheet
from openpyxl.styles.numbers import BUILTIN_FORMATS, BUILTIN_FORMATS_REVERSE

# pylint: disable=import-outside-toplevel

ZH_TW_ADDITION_FORMATS = {
    27: '[$-404]e/m/d',
    28: '[$-404]e"年"m"月"d"日"',
    29: '[$-404]e"年"m"月"d"日"',
    30: 'm/d/yy',
    31: 'yyyy"年"m"月"d"日"',
    32: 'hh"時"mm"分"',
    33: 'hh"時"mm"分"ss"秒"',
    34: '上午/下午 hh"時"mm"分"',
    35: '上午/下午 hh"時"mm"分"ss"秒"',
    36: '[$-404]e/m/d',
    50: '[$-404]e/m/d',
    51: '[$-404]e"年"m"月"d"日"',
    52: '上午/下午 hh"時"mm"分"',
    53: '上午/下午 hh"時"mm"分"ss"秒"',
    54: '[$-404]e"年"m"月"d"日"',
    55: '上午/下午 hh"時"mm"分"',
    56: '上午/下午 hh"時"mm"分"ss"秒"',
    57: '[$-404]e/m/d',
    58: '[$-404]e"年"m"月"d"日"',
}
ZH_CN_ADDITION_FORMATS = {
    27: 'yyyy"年"m"月"',
    28: 'm"月"d"日"',
    29: 'm"月"d"日"',
    30: 'm-d-yy',
    31: 'yyyy"年"m"月"d"日"',
    32: 'h"时"mm"分"',
    33: 'h"时"mm"分"ss"秒"',
    34: '上午/下午 h"时"mm"分"',
    35: '上午/下午 h"时"mm"分"ss"秒"',
    36: 'yyyy"年"m"月"',
    50: 'yyyy"年"m"月"',
    51: 'm"月"d"日"',
    52: 'yyyy"年"m"月"',
    53: 'm"月"d"日"',
    54: 'm"月"d"日"',
    55: '上午/下午 h"时"mm"分"',
    56: '上午/下午 h"时"mm"分"ss"秒"',
    57: 'yyyy"年"m"月"',
    58: 'm"月"d"日"',
}


def inject_imports(locale):
    import openpyxl.workbook.workbook
    openpyxl.workbook.workbook.ReadOnlyWorksheet = SynoReadOnlyWorksheet
    import openpyxl.reader.excel
    from .strings import read_string_table
    openpyxl.reader.excel.read_string_table = read_string_table

    addition_formats = None
    if locale == 'zh_TW':
        addition_formats = ZH_TW_ADDITION_FORMATS
    elif locale == 'zh_CN':
        addition_formats = ZH_CN_ADDITION_FORMATS
    if addition_formats is not None:
        BUILTIN_FORMATS.update(addition_formats)
        # pylint: disable=consider-using-dict-comprehension
        BUILTIN_FORMATS_REVERSE.update(
            dict([(v, k) for k, v in addition_formats.items()]))
