from openpyxl.worksheet._write_only import WriteOnlyWorksheet
from .worksheet_writer import SynoWorksheetWriter


class SynoWorksheet(WriteOnlyWorksheet):

    def __init__(self, *args, **kwargs):
        super(SynoWorksheet, self).__init__(*args, **kwargs)
        self.dimension = None
        self.data_validations = None
        self.__saved = False

    def write_data(self, outputer, dimension):
        self.dimension = dimension
        self._writer = SynoWorksheetWriter(self, outputer)
        self._writer.write()

    # called by WorksheetWriter.write_dimensions
    def calculate_dimension(self):
        return self.dimension

    @property
    def closed(self):
        return self.__saved

    def close(self):
        if self.__saved:
            self._already_saved()
        if self._writer is not None:
            self._writer.close()
        self.__saved = True
