<?php
namespace PhpOffice\PhpWord\Writer\Word2007\Element;

use PhpOffice\PhpWord\Element\TOCRun as TOCRunEl;
use PhpOffice\PhpWord\Shared\XMLWriter;

class TOCRun extends Text
{
    /**
     * Write element.
     *
     * @return void
     */
    public function write()
    {
        $xmlWriter = $this->getXmlWriter();
        $element = $this->getElement();

        if (!$element instanceof TOCRunEl) {
            return;
        }

        $xmlWriter->startElement('w:sdt');

        // Properties
        $xmlWriter->startElement('w:sdtPr');
        $xmlWriter->writeElementBlock('w:id', 'w:val', rand(100000000, 999999999));
        $xmlWriter->writeElementBlock('w:lock', 'w:val', 'sdtLocked');
        $xmlWriter->startElement("w:docPartObj");
        $xmlWriter->writeElementBlock('w:docPartGallery', 'w:val', 'Table of Contents');
        $xmlWriter->startElement('w:docPartUnique');
        $xmlWriter->endElement(); // w:docPartUnique
        $xmlWriter->endElement(); // w:docPartObj
        $xmlWriter->endElement(); // w:sdtPr

        // Content
        $xmlWriter->startElement('w:sdtContent');

        $containerWriter = new Container($xmlWriter, $element);
        $containerWriter->write();

        $xmlWriter->startElement('w:p');
        $xmlWriter->startElement('w:r');
        $xmlWriter->startElement('w:rPr');
        $xmlWriter->startElement('w:b');
        $xmlWriter->endElement();
        $xmlWriter->startElement('w:bCs');
        $xmlWriter->endElement();
        $xmlWriter->endElement();
        $xmlWriter->writeElementBlock('w:fldChar', 'w:fldCharType', 'end');
        $xmlWriter->endElement();
        $xmlWriter->endElement();

        $xmlWriter->endElement(); // w:sdtContent

        $xmlWriter->endElement(); // w:sdt
    }
}
